-------------------------------------------------------------------------------
--
-- Title       : No Title
-- Design      : FeuxCarrefour
-- Author      : max
-- Company     : max
--
-------------------------------------------------------------------------------
--
-- File        : d:\__ALTIUM_RNR_Mars2013\ALDEC Active-HDL\Feux_Carrefour\FeuxCarrefour\compile\FeuxCarrefour.vhd
-- Generated   : 03/17/13 02:25:01
-- From        : d:\__ALTIUM_RNR_Mars2013\ALDEC Active-HDL\Feux_Carrefour\FeuxCarrefour\src\FeuxCarrefour.asf
-- By          : FSM2VHDL ver. 5.0.7.2
--
-------------------------------------------------------------------------------
--
-- Description : 
--
-------------------------------------------------------------------------------

library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.std_logic_arith.all;
use IEEE.std_logic_unsigned.all;

entity FeuxCarrefour is 
	port (
		BP1: in STD_LOGIC;
		BP2: in STD_LOGIC;
		CLK: in STD_LOGIC;
		RAZ: in STD_LOGIC;
		O_SB: out STD_LOGIC;
		O_SC: out STD_LOGIC;
		R_SB: out STD_LOGIC;
		R_SC: out STD_LOGIC;
		V_SB: out STD_LOGIC;
		V_SC: out STD_LOGIC);
end FeuxCarrefour;

architecture FeuxCarrefour_arch of FeuxCarrefour is

constant TEMPO_S15S0: INTEGER := 15;
constant TEMPO_S28S15: INTEGER := 13;
constant TEMPO_S38S32: INTEGER := 6;
constant TEMPO_S45S42: INTEGER := 3;
constant TEMPO_S56S45: INTEGER := 11;
constant TEMPO_S66S56: INTEGER := 10;
constant TEMPO_S73S69: INTEGER := 4;
constant TEMPO_S80S76: INTEGER := 4;
-- SYMBOLIC ENCODED state machine: Sreg0
type Sreg0_type is (
    INIT, S0, S15, S28, S29, S32, S38, S39, S42, S45, S56, S66, S67, S69, S76, S73
);
-- attribute enum_encoding of Sreg0_type: type is ... -- enum_encoding attribute is not supported for symbolic encoding

signal Sreg0: Sreg0_type;

begin


----------------------------------------------------------------------
-- Machine: Sreg0
----------------------------------------------------------------------
Sreg0_machine: process (CLK)
-- machine variables declarations
variable tempo: INTEGER;

begin
	if CLK'event and CLK = '1' then
		if RAZ='0' then	
			Sreg0 <= INIT;
			-- Set default values for outputs, signals and variables
			-- ...
			tempo := 0;
		else
			-- Set default values for outputs, signals and variables
			-- ...
			case Sreg0 is
				when INIT =>
					Sreg0 <= S0;
				when S0 =>
					tempo := tempo+1;
					if tempo<TEMPO_S15S0 then	
						Sreg0 <= S0;
					else
						Sreg0 <= S15;
						tempo := 0;
					end if;
				when S15 =>
					tempo := tempo+1;
					if tempo<TEMPO_S28S15 then	
						Sreg0 <= S15;
					else
						Sreg0 <= S28;
						tempo := 0;
					end if;
				when S28 =>
					Sreg0 <= S29;
				when S29 =>
					tempo := tempo+1;
					if tempo<3 then	
						Sreg0 <= S29;
					else
						Sreg0 <= S32;
						tempo := 0;
					end if;
				when S32 =>
					tempo := tempo+1;
					if tempo<TEMPO_S38S32 then	
						Sreg0 <= S32;
					else
						Sreg0 <= S38;
					end if;
				when S38 =>
					Sreg0 <= S39;
					tempo := 0;
				when S39 =>
					tempo := tempo+1;
					if tempo<3 then	
						Sreg0 <= S39;
					else
						Sreg0 <= S42;
						tempo := 0;
					end if;
				when S42 =>
					tempo := tempo+1;
					if tempo<TEMPO_S45S42 then	
						Sreg0 <= S42;
					else
						Sreg0 <= S45;
						tempo := 0;
					end if;
				when S45 =>
					tempo := tempo+1;
					if tempo < TEMPO_S56S45 then	
						Sreg0 <= S45;
					else
						Sreg0 <= S56;
						tempo := 0;
					end if;
				when S56 =>
					tempo := tempo+1;
					if tempo<TEMPO_S66S56 then	
						Sreg0 <= S56;
					else
						Sreg0 <= S66;
					end if;
				when S66 =>
					Sreg0 <= S67;
					tempo := 0;
				when S67 =>
					tempo := tempo+1;
					if tempo<2 then	
						Sreg0 <= S67;
					else
						Sreg0 <= S69;
						tempo := 0;
					end if;
				when S69 =>
					tempo := tempo+1;
					if tempo<TEMPO_S73S69 then	
						Sreg0 <= S69;
					else
						Sreg0 <= S73;
						tempo := 0;
					end if;
				when S76 =>
					tempo := tempo+1;
					if tempo<TEMPO_S80S76 then	
						Sreg0 <= S76;
					else
						Sreg0 <= S0;
						tempo := 0;
					end if;
				when S73 =>
					tempo := tempo+1;
					if tempo<3 then	
						Sreg0 <= S73;
					else
						Sreg0 <= S76;
						tempo := 0;
					end if;
--vhdl_cover_off
				when others =>
					null;
--vhdl_cover_on
			end case;
		end if;
	end if;
end process;

-- signal assignment statements for combinatorial outputs
V_SB_assignment:
V_SB <= '1' when (Sreg0 = INIT) else
        '1' when (Sreg0 = S0) else
        '1' when (Sreg0 = S15) else
        '1' when (Sreg0 = S28) else
        '1' when (Sreg0 = S29) else
        '1' when (Sreg0 = S32) else
        '1' when (Sreg0 = S38) else
        '0' when (Sreg0 = S39) else
        '0' when (Sreg0 = S42) else
        '0' when (Sreg0 = S45) else
        '0' when (Sreg0 = S56) else
        '0' when (Sreg0 = S66) else
        '0' when (Sreg0 = S67) else
        '0' when (Sreg0 = S69) else
        '0' when (Sreg0 = S76) else
        '0' when (Sreg0 = S73) else
        '1';

O_SB_assignment:
O_SB <= '1' when (Sreg0 = INIT) else
        '0' when (Sreg0 = S0) else
        '0' when (Sreg0 = S15) else
        '0' when (Sreg0 = S28) else
        '0' when (Sreg0 = S29) else
        '0' when (Sreg0 = S32) else
        '0' when (Sreg0 = S38) else
        '1' when (Sreg0 = S39) else
        '0' when (Sreg0 = S42) else
        '0' when (Sreg0 = S45) else
        '0' when (Sreg0 = S56) else
        '0' when (Sreg0 = S66) else
        '0' when (Sreg0 = S67) else
        '0' when (Sreg0 = S69) else
        '0' when (Sreg0 = S76) else
        '0' when (Sreg0 = S73) else
        '1';

R_SB_assignment:
R_SB <= '1' when (Sreg0 = INIT) else
        '0' when (Sreg0 = S0) else
        '0' when (Sreg0 = S15) else
        '0' when (Sreg0 = S28) else
        '0' when (Sreg0 = S29) else
        '0' when (Sreg0 = S32) else
        '0' when (Sreg0 = S38) else
        '0' when (Sreg0 = S39) else
        '1' when (Sreg0 = S42) else
        '1' when (Sreg0 = S45) else
        '1' when (Sreg0 = S56) else
        '1' when (Sreg0 = S66) else
        '1' when (Sreg0 = S67) else
        '1' when (Sreg0 = S69) else
        '1' when (Sreg0 = S76) else
        '1' when (Sreg0 = S73) else
        '1';

V_SC_assignment:
V_SC <= '1' when (Sreg0 = INIT) else
        '0' when (Sreg0 = S0) else
        '0' when (Sreg0 = S15) else
        '0' when (Sreg0 = S28) else
        '0' when (Sreg0 = S29) else
        '0' when (Sreg0 = S32) else
        '0' when (Sreg0 = S38) else
        '0' when (Sreg0 = S39) else
        '0' when (Sreg0 = S42) else
        '1' when (Sreg0 = S45) else
        '1' when (Sreg0 = S56) else
        '1' when (Sreg0 = S66) else
        '1' when (Sreg0 = S67) else
        '1' when (Sreg0 = S69) else
        '0' when (Sreg0 = S76) else
        '0' when (Sreg0 = S73) else
        '1';

O_SC_assignment:
O_SC <= '1' when (Sreg0 = INIT) else
        '0' when (Sreg0 = S0) else
        '0' when (Sreg0 = S15) else
        '0' when (Sreg0 = S28) else
        '0' when (Sreg0 = S29) else
        '0' when (Sreg0 = S32) else
        '0' when (Sreg0 = S38) else
        '0' when (Sreg0 = S39) else
        '0' when (Sreg0 = S42) else
        '0' when (Sreg0 = S45) else
        '0' when (Sreg0 = S56) else
        '0' when (Sreg0 = S66) else
        '0' when (Sreg0 = S67) else
        '0' when (Sreg0 = S69) else
        '0' when (Sreg0 = S76) else
        '1' when (Sreg0 = S73) else
        '1';

R_SC_assignment:
R_SC <= '1' when (Sreg0 = INIT) else
        '1' when (Sreg0 = S0) else
        '1' when (Sreg0 = S15) else
        '1' when (Sreg0 = S28) else
        '1' when (Sreg0 = S29) else
        '1' when (Sreg0 = S32) else
        '1' when (Sreg0 = S38) else
        '1' when (Sreg0 = S39) else
        '1' when (Sreg0 = S42) else
        '0' when (Sreg0 = S45) else
        '0' when (Sreg0 = S56) else
        '0' when (Sreg0 = S66) else
        '0' when (Sreg0 = S67) else
        '0' when (Sreg0 = S69) else
        '1' when (Sreg0 = S76) else
        '0' when (Sreg0 = S73) else
        '1';

end FeuxCarrefour_arch;
